c     ******************************************************************
c     ****   function tgprof3  *****************************************
c     ******************************************************************
c
c
c
      function tgprof3(xteffe, xgravi, xangle, xwavel, lokexe)
c
c
c
      parameter (mchlin =    5)
      parameter (mchlot =    6)
      parameter (mzangs =   20)
      parameter (mzgrav =   20)
      parameter (mzteff =   30)
      parameter (mzwavs =10000)
c
      include '/star/include/sae_par'
c
      character*(80) cenvar
      character*(80) envstr
c
      dimension xzangs(mzangs)
      dimension xzgrav(mzgrav)
      dimension xzteff(mzteff)
      dimension xzwavs(mzwavs)
      dimension lzgrid(mzgrav,mzteff)
      dimension yzgrid(mzwavs,0:mzangs,mzgrav,mzteff)
c
      logical   lokexe
      logical   ldebug
      logical   lzgrid
c
      save
c
      ldebug = .false.
c
      if (xteffe.le.0.) then
c
c     get grid parameters from environment variables ...
c
         write(mchlot,'(''   Initializing tgprof3 [ver: 20 Mar 97]'')')
         ndimen = 2
         ninter = 2
         cenvar = '$TGKIEL_IGRID'
         xztmin = envnum('$TGKIEL_TMIN',mchlot,lokexe)
         xztmax = envnum('$TGKIEL_TMAX',mchlot,lokexe)
         xzgmin = envnum('$TGKIEL_GMIN',mchlot,lokexe)
         xzgmax = envnum('$TGKIEL_GMAX',mchlot,lokexe)
         xztint = envnum('$TGKIEL_TINT',mchlot,lokexe)
         xzgint = envnum('$TGKIEL_GINT',mchlot,lokexe)
         xzwmin = envnum('$TGKIEL_WMIN',mchlot,lokexe)
         xzwmax = envnum('$TGKIEL_WMAX',mchlot,lokexe)
c
c     initialise hds ...
c
         istats = sai__ok
         call hds_start(istats)
c     
         izangs = 0
         call zload2(
     &   cenvar, ndimen, izangs,
     &   xztmin, xztmax, xztint,
     &   xzgmin, xzgmax, xzgint,
     &   xzwmin, xzwmax,
     &   yzgrid, lzgrid,
     &   xzwavs, xzangs, xzgrav, xzteff,
     &   mzwavs, mzangs, mzgrav, mzteff,
     &   nzwavs, nzangs, nzgrav, nzteff,
     &   ldebug, mchlin, mchlot, lokexe)
c
         tgprof3 = 0.
c
c     shut down hds ...
c
         call hds_stop(istats)
c     
      else
         call tgint3(
     &   xwavel, xangle, xgravi, xteffe,
     &   ninter, ldebug, yzgrid, lzgrid,
     &   xzwavs, xzangs, xzgrav, xzteff,
     &   mzwavs, mzangs, mzgrav, mzteff,
     &   nzwavs, nzangs, nzgrav, nzteff,
     &   yinten, mchlin, mchlot, lokexe)
c
         tgprof3 = yinten
c     
      endif
c
c
c
      end
c     ******************************************************************
c     ***   subroutine tgint3   ****************************************
c     ******************************************************************
c
c
c
      subroutine tgint3(xwavel, xangle, xgravi, xteffe,
     &                  ninter, ldebug, yzgrid, lzgrid,
     &                  xzwavs, xzangs, xzgrav, xzteff,
     &                  mzwavs, mzangs, mzgrav, mzteff,
     &                  nzwavs, nzangs, nzgrav, nzteff,
     &                  yinten, mchlin, mchlot, lokexe)
c
c
c
      parameter    (epslon = 1.e-6)
c
c     imported arrays ...
c
      dimension     xzangs(mzangs)
      dimension     xzgrav(mzgrav)
      dimension     xzteff(mzteff)
      dimension     xzwavs(mzwavs)
      dimension     lzgrid(mzgrav,mzteff)
      dimension     yzgrid(mzwavs,0:mzangs,mzgrav,mzteff)
c
      logical       ldebug
      logical       lextra
      logical       lokint
      logical       lokexe
      logical       lzgrid
c
      data zteffe, zgravi, zangle, zwavel / -9., -9.,-9.,-9. /
c
c     save local variables so that we only re-locate if necessary ...
c
      save
c
c     initialise execution flag
c
      lokexe = .false.
c
      if ((xteffe.ne.zteffe).or.(xgravi.ne.zgravi)) then
c
c     locate indices in teff and logg arrays for interpolation ...
c     determine the optimal location for the interpolation
c     rectangle within the constraints of the model grid
c     degrading the interpolation order until a location can be
c     obtained
c
         lokint = .false.
         lextra = .false.
c
         xztmin = min(xzteff(1),xzteff(nzteff))
         xztmax = max(xzteff(1),xzteff(nzteff))
         yteffe = min(xztmax,max(xteffe,xztmin))
c
         xzgmin = min(xzgrav(1),xzgrav(nzgrav))
         xzgmax = max(xzgrav(1),xzgrav(nzgrav))
         ygravi = min(xzgmax,max(xgravi,xzgmin))
c
         call locate(xzteff,nzteff,yteffe,jteffe)
         call locate(xzgrav,nzgrav,ygravi,jgravi)
c
c        move the interpolating point back into the grid ...
c
         if (ldebug) write(mchlot,'(
     &   ''Original: '',
     &   ''('',f9.2,'','',f5.2,'') -> '',
     &   ''('',f9.2,'','',f5.2,'') = '',
     &   ''['',i2,'','',i2,'']'')')
     &   yteffe, ygravi,
     &   xzteff(jteffe), xzgrav(jgravi),
     &   jteffe, jgravi
c
         do while ((.not.lzgrid(jgravi+1,jteffe+1)).and.
     &   (jgravi.gt.1))
            ygravi = xzgrav(jgravi)
            jgravi = jgravi - 1
         enddo
c
         if (ldebug) write(mchlot,'(
     &   ''Adjusted: '',
     &   ''('',f9.2,'','',f5.2,'') -> '',
     &   ''('',f9.2,'','',f5.2,'') = '',
     &   ''['',i2,'','',i2,'']'')')
     &   yteffe, ygravi,
     &   xzteff(jteffe), xzgrav(jgravi),
     &   jteffe, jgravi
c
c        this loop tries to find an interpolating point for
c        a _given_ (teff,logg) pair by degrading the order
c        of the interpolating polynomial to a minimum of
c        linear interpolation
c
         nintry = ninter
         do while((.not.lokint).and.(nintry.ge.2))
c
            npteff = nintry
            npgrav = nintry
            lextra = .false.
c
            call tgloc3(
     &      yteffe,ygravi,lzgrid,
     &      xzgrav,xzteff,
     &      mzgrav,mzteff,
     &      nzgrav,nzteff,
     &      npteff,npgrav,
     &      kteffe,kgravi,
     &      lextra,ldebug,
     &      mchlin,mchlot,lokint)
c
            nintry = nintry - 1
         enddo
c
c     very bad news ...
c
         if (.not.lokint) then
            pause 'fatal error in tg3int'
         endif
c
      endif
c
c     locate index in angle array ...
c
      if (xangle.ne.zangle) then
         npangs = ninter
         xzamin = min(xzangs(1),xzangs(nzangs))
         xzamax = max(xzangs(1),xzangs(nzangs))
         yangle = min(xzamax,max(xangle,xzamin))
         call locate(xzangs,nzangs,yangle,kangle)
         kangle = min(max(kangle-(npangs-1)/2,1),nzangs+1-npangs)
      endif
c
c     locate index in wavelength array ...
c     (use hunt algorithm because input values are often correlated)
c
      if (xwavel.ne.zwavel) then
         npwavs = 2
         ywavel = min(xzwavs(nzwavs),max(xwavel,xzwavs(1)))
         kwavel = min(max(1,kwavel),nzwavs)
         call hunt(xzwavs,nzwavs,ywavel,kwavel)
         kwavel = min(max(kwavel-(npwavs-1)/2,1),nzwavs+1-npwavs)
      endif
c
c     call 4-d linear interpolation routine ...
c
      yinten = fline3(
     & xzwavs,xzangs,xzgrav,xzteff,yzgrid,
     & mzwavs,mzangs,mzgrav,mzteff,
     & kwavel,kangle,kgravi,kteffe,
     & ywavel,yangle,ygravi,yteffe)
c
c     a flag to indicate truncation ...
c
      if ((abs(yteffe-xteffe).gt.(epslon*xteffe)).or.
     &    (abs(ygravi-xgravi).gt.(epslon*xgravi)).or.
     &    (abs(yangle-xangle).gt.(epslon*xangle)).or.
     &    (abs(ywavel-xwavel).gt.(epslon*xwavel))) then
         lokexe = .false.
      else
         lokexe = .true.
      endif
c
c     finally save the calling parameters ...
c
      zteffe = xteffe
      zgravi = xgravi
      zangle = xangle
      zwavel = xwavel
c
c     for debugging purposes ...
c
      if (ldebug) then
         write(mchlot,'('' Input: '',f8.1,2x,f5.3,2x,f5.3,2x,f9.3)')
     & xteffe, xgravi, xangle, xwavel
         write(mchlot,'(''  Used: '',f8.1,2x,f5.3,2x,f5.3,2x,f9.3)')
     & yteffe, ygravi, yangle, ywavel
      endif
c
c
c
      end
c     ******************************************************************
c     ***   subroutine tgloc3   ****************************************
c     ******************************************************************
c
c
c
      subroutine tgloc3(teffec, gravit, lzgrid, 
     &                  xzgrav, xzteff,
     &                  mzgrav, mzteff,
     &                  nzgrav, nzteff,
     &                  nteffs, ngravs,
     &                  kteffm, kgravm,
     &                  lextra, ldebug,
     &                  mchlin, mchlot, lokexe)
c
c
c
      parameter (epslon = 1.e-6)
c
      dimension  xzgrav(mzgrav)
      dimension  xzteff(mzteff)
c
      dimension  lzgrid(mzgrav,mzteff)
c
      logical    ldebug
      logical    lextra
      logical    lokexe
      logical    lvalid
      logical    lzgrid
c
c     compute grid-spacing in teff and logg axes
c     under the assumption that the grid is uniformly
c     spaced local to the point at which the interpolation
c     is to be carried out
c     increment teff and logg coordinates by epslon to displace
c     interpolated point from grid intersections because locate
c     will search from _below_ in a monotonically _increasing_
c     array (the sign of the increments is chosen so as to
c     always shift into a more complete region of the grid) ...
c
      epstef = epslon*teffec
      epslgg = epslon*gravit
      call locate(xzteff,nzteff,teffec-epstef,kzteff)
      call locate(xzgrav,nzgrav,gravit+epslgg,kzgrav)
      jzteff = min(nzteff-1,max(1,kzteff))
      jzgrav = min(nzgrav-1,max(1,kzgrav))
      dzteff = xzteff(jzteff+1) - xzteff(jzteff)
      dzgrav = xzgrav(jzgrav+1) - xzgrav(jzgrav)
c
         if (ldebug) write(mchlot,'(
     &   '' Started: '',
     &   ''('',f9.2,'','',f5.2,'') -> '',
     &   ''('',f9.2,'','',f5.2,'') = '',
     &   ''['',i2,'','',i2,'']'')')
     &   teffec, gravit,
     &   xzteff(kzteff), xzgrav(kzgrav),
     &   kzteff, kzgrav
c
c     find the position of the interpolation rectangle for which the
c     square-deviation from the point (teffec,gravit) is a minimum
c     and for which there are valid (xzteff,xzgrav) values at every
c     point within the interpolation rectangle
c
c     assign ridiculously large initial value to "deltam"
c     set success flags "lokexe" to .false.
c
      kteffm = 0
      kgravm = 0
      lokexe = .false.
      deltam = 1.e30
c
c     loop through all points in grid which are valid coordinates
c     for top-left corner of interpolation rectangle
c     expand our range of consideration by one grid point if we
c     are allowing extrapolation ...
c
      if (lextra) then
         iztmin = min((nzteff-nteffs+1),max(1,(kzteff-nteffs+1)))
         iztmax = min((nzteff-nteffs+1),max(1,kzteff+1))
         izgmin = min((nzgrav-ngravs+1),max(1,(kzgrav-ngravs+1)))
         izgmax = min((nzgrav-ngravs+1),max(1,kzgrav+1))
      else
         iztmin = min((nzteff-nteffs+1),max(1,(kzteff-nteffs+2)))
         iztmax = min((nzteff-nteffs+1),max(1,kzteff))
         izgmin = min((nzgrav-ngravs+1),max(1,(kzgrav-ngravs+2)))
         izgmax = min((nzgrav-ngravs+1),max(1,kzgrav))
      endif
c
      do izteff = iztmin, iztmax
         do izgrav = izgmin, izgmax
c
c     loop through all points in interpolation rectangle and evaluate
c     all elements of logic matrix "lzgrid" are .true.
c     (i.e. grid models available for all interpolation points)
c     intially assume interpolation is valid
c
            lvalid = .true.
c
            do jzteff = izteff, (izteff+nteffs-1)
               do jzgrav = izgrav, (izgrav+ngravs-1)
                  if (.not.lzgrid(jzgrav,jzteff)) lvalid = .false.
               enddo
            enddo
c
c     calculate square-deviation
c
            deltax = ((xzteff(izteff+nteffs/2)-teffec)/dzteff)**2 +
     &      ((xzgrav(izgrav+ngravs/2)-gravit)/dzgrav)**2
c
c     if interpolation rectangle is valid then test square-deviation
c     against current minimum
c
            if ((lvalid).and.(deltax.le.deltam)) then
               deltam = deltax
               kteffm = izteff
               kgravm = izgrav
               lokexe = .true.
            endif
c
         if (ldebug) write(mchlot,'(
     &   ''  Tested: '',
     &   ''('',f9.2,'','',f5.2,'') -> '',
     &   ''('',f9.2,'','',f5.2,'') = '',
     &   ''['',i2,'','',i2,''] ;'',
     &   '' dev = '',1pe8.2,''; valid = '',l)')
     &   teffec, gravit,
     &   xzteff(izteff), xzgrav(izgrav),
     &   izteff, izgrav,
     &   deltax, lvalid
c
         enddo
      enddo
c
      if (lokexe) then
c
         if (ldebug) write(mchlot,'(
     &   ''Selected: '',
     &   ''('',f9.2,'','',f5.2,'') -> '',
     &   ''('',f9.2,'','',f5.2,'') = '',
     &   ''['',i2,'','',i2,''] ;'',
     &   '' dev = '',1pe8.2)')
     &   teffec, gravit,
     &   xzteff(kteffm), xzgrav(kgravm),
     &   kteffm, kgravm,
     &   deltam
c
         tsense = sign(1.,(xzteff(kteffm+nteffs-1)-xzteff(kteffm)))
         gsense = sign(1.,(xzgrav(kgravm+ngravs-1)-xzgrav(kgravm)))
c
         if ((tsense*(teffec-xzteff(kteffm)).lt.(-epstef)).or.
     &   (tsense*(teffec-xzteff(kteffm+nteffs-1)).gt.(epstef)).or.
     &   (gsense*(gravit-xzgrav(kgravm)).lt.(-epslgg)).or.
     &   (gsense*(gravit-xzgrav(kgravm+ngravs-1)).gt.(epslgg))) then
            lextra = .true.
         else
            lextra = .false.
         endif
c
      endif
c
c
c
      end
c     ******************************************************************
c     ****   function fline3   *****************************************
c     ******************************************************************
c
c     a special tetra-linear interpolation routine for tgprof written as
c     a generalisation of the bi-linear formulae given in nr2, p. 117.
c
      function fline3(x1a, x2a, x3a, x4a, ya,
     &                 m1,  m2,  m3,  m4,
     &                  i,   j,   k,   l,
     &                 x1,  x2,  x3,  x4)
c
c
c
      dimension x1a(m1)
      dimension x2a(m2)
      dimension x3a(m3)
      dimension x4a(m4)
      dimension ya(m1,0:m2,m3,m4)
c
      t = (x1-x1a(i))/(x1a(i+1)-x1a(i))
      u = (x2-x2a(j))/(x2a(j+1)-x2a(j))
      v = (x3-x3a(k))/(x3a(k+1)-x3a(k))
      w = (x4-x4a(l))/(x4a(l+1)-x4a(l))
c
      fline3 =
     &     (1.-t)*(1.-u)*(1.-v)*(1.-w)*ya(i  ,j  ,k  ,l  ) +
     &         t *(1.-u)*(1.-v)*(1.-w)*ya(i+1,j  ,k  ,l  ) +
     &     (1.-t)*    u *(1.-v)*(1.-w)*ya(i  ,j+1,k  ,l  ) +
     &     (1.-t)*(1.-u)*    v *(1.-w)*ya(i  ,j  ,k+1,l  ) +
     &     (1.-t)*(1.-u)*(1.-v)*    w *ya(i  ,j  ,k  ,l+1) +
     &         t *    u *(1.-v)*(1.-w)*ya(i+1,j+1,k  ,l  ) +
     &     (1.-t)*    u *    v *(1.-w)*ya(i  ,j+1,k+1,l  ) +
     &     (1.-t)*(1.-u)*    v *    w *ya(i  ,j  ,k+1,l+1) +
     &         t *(1.-u)*    v *(1.-w)*ya(i+1,j  ,k+1,l  ) +
     &     (1.-t)*    u *(1.-v)*    w *ya(i  ,j+1,k  ,l+1) +
     &         t *(1.-u)*(1.-v)*    w *ya(i+1,j  ,k  ,l+1) +
     &         t *    u *    v *(1.-w)*ya(i+1,j+1,k+1,l  ) +
     &     (1.-t)*    u *    v *    w *ya(i  ,j+1,k+1,l+1) +
     &         t *(1.-u)*    v *    w *ya(i+1,j  ,k+1,l+1) +
     &         t *    u *(1.-v)*    w *ya(i+1,j+1,k  ,l+1) +
     &         t *    u *    v *    w *ya(i+1,j+1,k+1,l+1)
c
c
c
      end
